# -*- coding: utf-8 -*-
"""
@author: Joep Lustenhouwer and Kostas Mavromatis
"""

from jmcb_exp_fun_wage import *
import numpy as np
import matplotlib.pyplot as plt
import matplotlib as mpl

from scipy.optimize import fsolve


plot = plt.plot


N=32



C=[[0]*(N) for hhh in range(4)]
Y=[[0]*N   for hhh in range(4)]
R=[[0]*N   for hhh in range(4)]
P=[[0]*N  for hhh in range(4)]
B=[[0]*N  for hhh in range(4)]
K=[[0]*N  for hhh in range(4)]
INV=[[0]*N  for hhh in range(4)]
Z=[[0]*N  for hhh in range(4)]
TQ=[[0]*N  for hhh in range(4)]
g=[[0]*N  for hhh in range(4)]
tau=[[0]*N   for hhh in range(4)]
Trans=[[0]*N   for hhh in range(4)]
LST=[[0]*N   for hhh in range(4)]
C=[[0]*N   for hhh in range(4)]
ri=[[0]*N   for hhh in range(4)]
H=[[0]*N   for hhh in range(4)]
H2=[[0]*N   for hhh in range(4)]
w=[[0]*N   for hhh in range(4)]
w2=[[0]*N   for hhh in range(4)]
mc=[[0]*N   for hhh in range(4)]
Pw=[[0]*N   for hhh in range(4)]
H4=[[0]*N   for hhh in range(4)]
rk=[[0]*N   for hhh in range(4)]

mc=[[0]*(N) for hhh in range(4)]
prof=[[0]*(N) for hhh in range(4)]

Ey1=[0]*N 
Ep1=[0]*N 
Eb1=[0]*N 
Er1=[0]*N 
Ek1=[0]*N  
Ez1=[0]*N  
Ei1=[0]*N  
ET1=[0]*N  
Ew1=[0]*N  
Epw1=[0]*N  


Ey=[0]*N 
Ep=[0]*N 
Eg=[0]*N 

param=dict(
    T=12, #no paramters that depend on T are used in the below code, but T needs ot be set to be able to use the more general function UpdateParam from whuch some composite paraamaers of the model are obtained
    fount=1-0.99,
    beta=0.99,
    omega=0.8,
    omega_w=1e-100,  #Wage stickyness. Code is flexible enough to introduce this, but for the results in the paper, set it to virtually zero (e.g. 1e-100)
    eta=1.5, 
    sigma=2,
    zeta=0.2,  #power on kaptial in production function
    theta=2,
    theta_w=2,
    phi_1=1.5,
    phi_2=0.2,
    phi_b=0.06,
    sstau=0.4,
    ssg=0.2,
    ssb=0.7,
    gamma1=1/0.99-1+0.025,   
    gamma2=0.05,
    delta=0.025,    #depreciation rate
    kappa= 17, #investment adjustmentcost
    lamb=0.7
    )



pers_gs=0.97
pers_ts=0.97
pers_tr=0.97

param=UpdateParam(**param)  

# Y P b R K Z I LT w Wp Q g tau transfers

A=np.zeros((14,14))

A[0]=[param['ssy']/param['ssc']-param['lamb']*param['mu_p']/(1-param['zeta']),0,0,(1-param['lamb'])/param['sigma'],
  -param['lamb']*param['mu_p']*param['zeta']/(1-param['zeta']),-param['gamma1']*param['ssk']/param['ssc']+param['lamb']*param['mu_p']*param['zeta']/(1-param['zeta']),
  -param['ssi']/param['ssc'],param['lamb']*param['ssy']/param['ssc'],-param['lamb']*param['mu_p'],0,0,-param['ssy']/param['ssc'],param['lamb']*param['mu_p']/(1-param['sstau']),0 ] 
A[1]=[0,1,0,0,0,-param['k_z'],0,0,-param['k_w'],0,0,0,0,0]
A[2]=[-param['b_y'],param['ssb']/param['beta'],1,-param['ssb'],0,-param['b_z'],0,1/param['beta'],-param['b_w'],0,0,-param['b_g'],-param['b_tau'],0]
A[3]=[-param['phi_2'],-param['phi_1'],0,1,0,0,0,0,0,0,0,0,0,0]
A[4]=[0,0,0,0,1,0,-param['ssi']/param['ssk'],0,0,0,0,0,0,0]
A[5]=[-param['z_y'],0,0,0,0,param['z_z'],0,0,-param['z_w'],0,0,0,0,0]
A[6]=[0,0,0,0,0,0,1,0,0,0,-(1-param['lamb'])/(param['kappa']*(1+param['beta'])),0,0,0]
A[7]=[0,0,0,0,0,0,0,1,0,0,0,0,0,1]
A[8]=[0,1,0,0,0,0,0,0,1,-1,0,0,0,0]
A[9]=[-param['w_w_inf']*(param['eta']/(1-param['zeta'])+param['sigma']*param['ssy']/param['ssc']),0,0,0,
  0,param['w_w_inf']*(param['eta']*param['zeta']/(1-param['zeta'])+param['sigma']*param['ssk']*param['gamma1']/param['ssc']),
  param['w_w_inf']*param['sigma']*param['ssi']/param['ssc'],0,param['w_w_inf'],1,0,param['w_w_inf']*param['sigma']*param['ssy']/param['ssc'],-param['w_w_inf']/(1-param['sstau']),0]
A[10]=[0,0,0,1,0,0,0,0,0,0,1,0,0,0]
A[11]=[0,0,0,0,0,0,0,0,0,0,0,1,0,0]
A[12]=[0,0,0,0,0,0,0,0,0,0,0,0,1,0]
A[13]=[0,0,0,0,0,0,0,0,0,0,0,0,0,1]

shock=0.01


def calc_curr(vr,lags,shocks,F,Q):
    return np.dot(F[vr,:],lags)+np.dot(Q[vr,11:14],shocks)

types=[3,10]
for spen in types:  #1 is spending; 0 is tax; 3 is transfers; 2 is no fsical intervention

    lags=np.zeros(14)

    
    Update_hd_pol=1 #new policy functions for the high debt steady tstate path need to be calcualted untill this is set to zero

    
    for i in range(1,N):
        if i==1:
            if spen==1:
                shocks=np.array([shock,0,0])
            elif spen==0:
                shocks=np.array([0,-shock*param['ssy']/(param['ssh']*param['ssw']),0])  #/param['ssw'
            elif spen==3:
                shocks=np.array([0,0,shock])
            else:
                shocks=np.zeros(3)
        else:
            shocks=np.zeros(3)
            
          

# Y P b R K Z I LT w Wp Q g tau Transfers

        if Update_hd_pol==1:        
    
    
    
            BR=np.zeros((14,14))
            CR=np.zeros((14,14))
            
  
   
            BR[0]=[param['ssy']/param['ssc']-param['lamb']*param['mu_p']/(1-param['zeta']),(1-param['lamb'])/param['sigma'],0,0,
             0,-param['gamma1']*param['ssk']/param['ssc']+param['lamb']*param['mu_p']*param['zeta']/(1-param['zeta']),
              -param['ssi']/param['ssc'],param['lamb']*param['ssy']/param['ssc'],-param['lamb']*param['mu_p'],0,0,-param['ssy']/param['ssc'],param['lamb']*param['mu_p']/(1-param['sstau']),0]          
            BR[1,1]=param['beta'] 
            BR[6,6]=param['beta']/(1+param['beta'])   
            BR[9,9]=param['beta']   
            BR[10]=[0,1,0,0,0,param['beta']*param['gamma2'],0,0,0,0,param['beta']*(1-param['delta']),0,0,0]
            
    
            CR[0,[2,4,6,8]]=[0, -param['lamb']*param['mu_p']*param['zeta']/(1-param['zeta']),0,0]
            CR[2,[2,4,6,8]]=[ param['bbl'],param['bkl'] , 0, 0]
            CR[4,[2,4,6,8]]=[ 0, (1-param['delta']), 0, 0]
            CR[5,[2,4,6,8]]=[0 ,param['zkl'] , 0, 0]
            CR[6,[2,4,6,8]]=[0 , 0, 1/(1+param['beta'])    , 0]
            CR[7,[2,4,6,8]]=[param['phi_b'] , 0, 0, 0] 
            CR[8,[2,4,6,8]]=[0 , 0, 0 , 1]
            CR[9,[2,4,6,8]]=[0 ,-param['w_w_inf']*param['eta']*param['zeta']/(1-param['zeta']), 0 , 0]
            CR[11,11]=pers_gs
            CR[12,12]=pers_ts
            CR[13,13]=pers_tr
            
            F=np.zeros((14,14))
            Fnew=np.ones((14,14))

            
            while np.max(np.abs(F-Fnew))>0.0000000000001:
                F=Fnew
                Fnew=np.dot(np.linalg.inv(A-np.dot(BR,F)),CR)  
    
            Q=np.linalg.inv(A-np.dot(BR,Fnew))
  
 
        curr=[calc_curr(vr,lags,shocks,F,Q) for vr in range(14)]
        Y[spen][i],P[spen][i],B[spen][i],R[spen][i],K[spen][i],Z[spen][i],INV[spen][i],LST[spen][i],w[spen][i],Pw[spen][i],TQ[spen][i],g[spen][i],tau[spen][i],Trans[spen][i]=curr
        
#        [Ey1[i],Ep1[i],Eb1[i],Er1[i],Ek1[i],Ez1[i],Ei1[i],ET1[i],Ew1[i],Epw1[i]]=[eval_pol(pol_matrix[1],var,B[spen][i-1],K[spen][i-1],INV[spen][i-1],g[spen][i],tau[spen][i],w[spen][i-1],Trans[spen][i],) for var in range(10)] 

      
        C[spen][i]=param['ssy']/param['ssc']*Y[spen][i]-param['ssi']/param['ssc']*INV[spen][i]-param['ssy']/param['ssc']*g[spen][i]-param['gamma1']*param['ssk']/param['ssc']*Z[spen][i]
        ri[spen][i-1]=R[spen][i-1]-P[spen][i]
        H[spen][i]=1/(1-param['zeta'])*Y[spen][i]-param['zeta']/(1-param['zeta'])*K[spen][i-1]-param['zeta']/(1-param['zeta'])*Z[spen][i]
        H2[spen][i]=1/param['eta']*(w[spen][i] -param['sigma']*C[spen][i]-tau[spen][i]/(1-param['sstau']))
        rk[spen][i]=param['gamma2']/param['gamma1']*Z[spen][i]
        mc[spen][i]=(1-param['zeta'])*w[spen][i] +param['zeta']*param['gamma2']/param['gamma1']*Z[spen][i]
#        
        lags=curr

Npl=min(N,1000)




for spen in types:            
    plt.figure() 
 
    if spen==1:
    
        plt.subplot(3, 3, 1)
        plot([(g[spen][i])*100 for i in range(Npl)],linewidth=2)
        #    plt.ylim((-0.1,0))
        plt.title('Government spending')
        plt.xlabel('t')
    
    if spen == 0:
        plt.subplot(3, 3, 1)
        plot([(tau[spen][i])*100 for i in range(Npl)],linewidth=2)
        #    plt.ylim((0,0.12))
        plt.title('Labor Taxes')
        plt.xlabel('t')
    
    if spen == 3:
        plt.subplot(3, 3, 1)
        plot([(Trans[spen][i])*100 for i in range(Npl)],linewidth=2)
        #    plt.ylim((0,0.12))
        plt.title('Transfers')
        plt.xlabel('t')
        
     
    plt.subplot(3, 3, 2)
    plot([(B[spen][i]+param['ssb'])*100 for i in range(Npl)],linewidth=2)
#    plt.ylim((70, 78))
    plt.title('Debt')
    plt.ylabel('b_t')
    plt.xlabel('t')



    plt.subplot(3, 3, 3)
    plot([(C[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Consumption')
    plt.ylabel('C_t')
    plt.xlabel('t')   
    
    
    plt.subplot(3, 3, 4)
    plot([(P[spen][i])*400 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.01,0.06))
    plt.title('inflation')
    plt.ylabel('pi_t')
    plt.xlabel('t')
    
  
    

    plt.subplot(3, 3, 5)
    plot([(R[spen][i])*400 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.01,0.04))
    plt.title('nominal interest rate')
    plt.ylabel('R_t')
    plt.xlabel('t')
    plt.show() 
    
    plt.subplot(3, 3, 6)
    plot([(INV[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Investment')
    plt.ylabel('I_t')
    plt.xlabel('t') 
    
    
    plt.subplot(3, 3, 7)
    plot([(K[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Kapital')
    plt.ylabel('Y_t')
    plt.xlabel('t') 
    

    
    plt.subplot(3, 3, 8)
    plot([(Z[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Kapital Utilization')
    plt.ylabel('Y_t')
    plt.xlabel('t') 


 
    plt.subplot(3, 3, 9)
    plot([(Y[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Output')
    plt.ylabel('Y_t')
    plt.xlabel('t')   
  
  


